#include < amxmodx >
#include < amxmisc >
#include < nvault >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >
#include < dhudmessage >

#include "ncodmod.inc"

#define inOtherTeam(%1,%2) bool:( get_user_team(%1) != get_user_team(%2) )

enum playerClassInfo 
{
	pciIdentificator,
	pciLevel,
	pciExperience,
	pciHealth,
	pciStrength,
	pciIntelligence,
	pciCondition,
	pciWeapons,
	pciInitialPoints
}

enum playerInfo 
{
	piName[ 33 ],
	piClass[ playerClassInfo ],
	Array: piClasses,
	piPerk,
	piPerkDurability,
	bool: piMenuFirstTime,
	bool: piMenuBlocked,
	piDistributePointsMode,
	Float: piNextEmitSound
}

enum classInfo 
{
	ciName[ 64 ],
	ciDescription[ 128 ],
	ciHealth,
	ciStrength,
	ciIntelligence,
	ciCondition,
	ciWeapons,
	ciTeam,
	ciAccessFlags,
	ciPlugin
}

enum itemInfo
{
	iiName[ 64 ],
	iiDescription[ 128 ],
	iiAccessFlags,
	iiPlugin
}

enum structBuffer
{
	cInfo[ classInfo ],
	iInfo[ itemInfo ],
	bLastC,
	bLastI,
	bHUDAddons[ 768 ]
}

enum structPluginInfo 
{
	plMaxLevel,
	plExperienceMultiplier,
	plMaxStatisticValue,
	plSaveDriver,
	plSaveMode,
	plReloadingSounds,
	plFriendlyFireSounds,
	plMySQLHost[ 128 ],
	plMySQLUser[ 128 ],
	plMySQLPassword[ 128 ],
	plMySQLDatabase[ 128 ],
	plMySQLPrefix[ 128 ]
}

enum structPluginSounds 
{
	psStart,
	psStart2,
	psLevelUp,
	psLevelDegraded,
	psReloading1,
	psReloading2,
	psReloading3,
	psCheckFire1,
	psCheckFire2,
	psCheckFire3,
	psSelectMenuItem,
	psPanicMessage
}

stock const gszStateInfo[ ][ ] =
{
	"Maksymalny poziom Zycia osiagniety!",
	"Maksymalny poziom Wytrzymalosci osiagniety!",
	"Maksymalny poziom Inteligencji osiagniety!",
	"Maksymalny poziom Kondycji osiagniety!"
}

stock const giStatistics[ NCodStatist ] = 
{
	ciHealth,
	ciStrength,
	ciIntelligence,
	ciCondition
}

stock const gszPluginSounds[ structPluginSounds ][ 128 ] =
{
	"NCodMod/start.wav",
	"NCodMod/start2.wav",
	"NCodMod/levelup.wav",
	"NCodMod/leveldegraded.wav",
	"NCodMod/reloading_01.wav",
	"NCodMod/reloading_02.wav",
	"NCodMod/reloading_03.wav",
	"NCodMod/check_fire_01.wav",
	"NCodMod/check_fire_02.wav",
	"NCodMod/check_fire_03.wav",
	"NCodMod/menu_select.wav",
	"NCodMod/message_panic.wav"
}

stock const gszWeaponsNames[ ][ ] = 
{
	"weapon_scout", "weapon_mac10", "weapon_aug", "weapon_ump45", 
	"weapon_sg550", "weapon_galil", "weapon_famas", "weapon_awp", 
	"weapon_mp5navy", "weapon_m249", "weapon_m4a1", "weapon_tmp", 
	"weapon_g3sg1", "weapon_sg552", "weapon_ak47", "weapon_p90",
	"weapon_p228", "weapon_shield", "weapon_hegrenade", "weapon_xm1014",
	"weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_usp",
	"weapon_glock18", "weapon_flashbang", "weapon_deagle"
}

stock const giDistributePointsModes[ ] = { 1, 15, -1 }

new gPluginInfo[ structPluginInfo ] =
{
	901, 127, 500, 1, 0, 1, 1, 
	"127.0.0.1",
	"root",
	"your_password",
	"your_lovely_database",
	"ncd_"
}

new gVault = -1;
new gSyncHUD;
new gPlayerInfo[ 33 ][ playerInfo ];
new gPlayerBuffer[ 33 ][ structBuffer ]

new Float: gfNextHUDRefresh[ 33 ]

new Array: gaClasses,
	Array: gaPerks,
	Array: gaHUDAddons
;

public plugin_init() 
{
	new const VERSION[ ] = "0.1 AlphaRev";

	register_plugin( "NewCodMod :: Engine", VERSION, "MarWit :: AMXX.PL" );
	register_cvar( "ncodmod_version", VERSION, FCVAR_SERVER | FCVAR_SPONLY );
	
	register_event( "DeathMsg", "eventDeathMsg", "a" );
	register_event( "TeamInfo", "eventChangeTeam", "a", "2=TERRORIST", "2=CT" );
	
	register_logevent( "eventRoundEnd", 2 , "1=Round_End" );
	
	RegisterHam( Ham_Spawn, "player", "hamSpawnPost", 1 );
	RegisterHam( Ham_CS_RoundRespawn, "player", "hamRoundRespawnPost", 1 );
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	RegisterHam( Ham_TraceAttack, "player", "hamTraceAttackPost", 1 );
	
	for( new i = 0; i < 16; i ++ )
		RegisterHam( Ham_Weapon_Reload, gszWeaponsNames[ i ], "hamWeaponReloading", 1 );
		
	RegisterHam( Ham_Weapon_Reload, "weapon_xm1014", "hamShotgunReloading", 1 );
	RegisterHam( Ham_Weapon_Reload, "weapon_m3", "hamShotgunReloading", 1 );
	
	RegisterHam( Ham_Touch, "armoury_entity", "hamWeaponTouch" );
	RegisterHam( Ham_Touch, "weapon_shield", "hamWeaponTouch" );
	RegisterHam( Ham_Touch, "weaponbox", "hamWeaponTouch" );
	
	RegisterHam( Ham_Item_PreFrame, "player", "hamResetMaxSpeed", 1 );
	
	register_forward( FM_EmitSound, "fwEmitSound" );
	register_forward( FM_PlayerPostThink, "fwPlayerPostThinkPost", 1 );
	
	__registerPluginCommands( );
	
	gSyncHUD = CreateHudSyncObj( );
}

public plugin_precache( )
{
	gaClasses = ArrayCreate( classInfo );
	gaPerks = ArrayCreate( itemInfo );
	gaHUDAddons = ArrayCreate( );
	
	for( new i = 0; i < sizeof( gszPluginSounds ); i++ )
		precache_sound( gszPluginSounds[ structPluginSounds: i ] );
	
	__loadConfigFile( );
}

public plugin_natives( )
{
	register_library( "NewCodMod-Library" );
	
	register_native( "ncod_registerClass", "nativeRegisterClass" );
	register_native( "ncod_registerPerk", "nativeRegisterPerk" );
	register_native( "ncod_getUserStatist", "nativeGetUserStatist" );
	register_native( "ncod_setUserStatist", "nativeSetUserStatist" );
	register_native( "ncod_printInformation", "nativePrintInformation" );
	register_native( "ncod_registerHUDAddon", "nativeRegisterHUDAddon" );
}

public plugin_cfg( )
{
	if( gPluginInfo[ plSaveDriver ] == 1 )
		gVault = nvault_open( "NewCodMod" );
	else if( gPluginInfo[ plSaveDriver ] == 2 )
		set_fail_state( "Zapis MySQL nie jest jeszcze zaimplementowany!" );
}
	
public plugin_end( )
{
	if( gPluginInfo[ plSaveDriver ] == 1 )
		nvault_close( gVault );
	
	ArrayDestroy( gaClasses );
	ArrayDestroy( gaPerks );
	ArrayDestroy( gaHUDAddons );
}

public client_connect( id )
	loadPlayer( id );
	
public client_disconnect( id )
{
	if( is_user_bot( id ) ) return;

	if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] != -1 )
	{
		new classBuffer[ classInfo ];
	
		ArraySetArray( gPlayerInfo[ id ][ piClasses ], gPlayerInfo[ id ][ piClass ][ pciIdentificator ], gPlayerInfo[ id ][ piClass ] );
		ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], classBuffer );
		
		new iForward, iRet;
		iForward = CreateOneForward( classBuffer[ ciPlugin ], "ncod_classChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], NCODSTATE_DISABLE )
		DestroyForward( iForward );
		
		gPlayerInfo[ id ][ piClass ][ pciIdentificator ] = -1;
	}
	
	if( gPlayerInfo[ id ][ piPerk ] != -1 )
	{
		new perkBuffer[ itemInfo ];
	
		ArrayGetArray( gaPerks, gPlayerInfo[ id ][ piPerk ], perkBuffer );
		
		new iForward, iRet;
		iForward = CreateOneForward( perkBuffer[ iiPlugin ], "ncod_perkChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piPerk ], NCODSTATE_DISABLE )
		DestroyForward( iForward );
		
		gPlayerInfo[ id ][ piPerk ] = -1;
		gPlayerInfo[ id ][ piPerkDurability ] = 0;
	}

	savePlayer( id );
}
	
public eventDeathMsg( )
{
	new iAttacker = read_data( 1 ), iThis = read_data( 2 ), bool: bHeadshot = bool: read_data( 3 );
	
	if( gPlayerInfo[ iAttacker ][ piPerk ] == -1 )
	{
		gPlayerInfo[ iAttacker ][ piPerk ] = random( ArraySize( gaPerks ) );
		gPlayerInfo[ iAttacker ][ piPerkDurability ] = 100;
		
		client_cmd( iAttacker, "echo %d | %d", ArraySize( gaPerks ), gPlayerInfo[ iAttacker ][ piPerk ] );
		
		new perkBuffer[ itemInfo ];
		ArrayGetArray( gaPerks, gPlayerInfo[ iAttacker ][ piPerk ], perkBuffer );
		
		new iForward, iRet;
		iForward = CreateOneForward( perkBuffer[ iiPlugin ], "ncod_perkChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, iAttacker, gPlayerInfo[ iAttacker ][ piPerk ], NCODSTATE_ENABLE )
		DestroyForward( iForward );
		
		printInformation( iAttacker, NCODINFOTYPE_CHAT, NCODINFOCOLOR_INFORMATION, "Znalazles perk: %s !", perkBuffer[ iiName ]  );
	}
	
	if( gPlayerInfo[ iThis ][ piPerk ] != -1 )
	{
		gPlayerInfo[ iThis ][ piPerkDurability ] -= ( bHeadshot ? 10 : 5 );
		
		if( gPlayerInfo[ iThis ][ piPerkDurability ] <= 0 )
		{
			gPlayerInfo[ iThis ][ piPerkDurability ] = 0;
		
			new perkBuffer[ itemInfo ];
			ArrayGetArray( gaPerks, gPlayerInfo[ iThis ][ piPerk ], perkBuffer );
		
			new iForward, iRet;
			iForward = CreateOneForward( perkBuffer[ iiPlugin ], "ncod_perkChangeState", FP_CELL, FP_CELL, FP_CELL );
			ExecuteForward( iForward, iRet, iThis, gPlayerInfo[ iAttacker ][ piPerk ], NCODSTATE_DISABLE )
			DestroyForward( iForward );
			
			gPlayerInfo[ iThis ][ piPerk ] = -1;
			
			printInformation( iThis, NCODINFOTYPE_CHAT, NCODINFOCOLOR_INFORMATION, "Twoj perk zostal zniszczony !", perkBuffer[ iiName ]  );
		}
	}
	
	if( gPlayerInfo[ iAttacker ][ piClass ][ pciLevel ] == gPluginInfo[ plMaxLevel ] )
		return;
		
	if( bHeadshot )
		gPlayerInfo[ iAttacker ][ piClass ][ pciExperience ] += 65 * gPlayerInfo[ iAttacker ][ piClass ][ pciLevel ];
	else
		gPlayerInfo[ iAttacker ][ piClass ][ pciExperience ] += 45 * gPlayerInfo[ iAttacker ][ piClass ][ pciLevel ];
		
	gPlayerInfo[ iThis ][ piMenuBlocked ] = false;
		
	checkPlayerLevel( iAttacker );
}

public eventChangeTeam( )
{
	static iOldTeam[ 33 ];
	new id = read_data( 1 );
	
	if( is_user_bot( id ) || iOldTeam[ id ] == get_user_team( id ) )
		return;
	
	new classBuffer[ classInfo ];

	if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] != -1 )
	{
		ArraySetArray( gPlayerInfo[ id ][ piClasses ], gPlayerInfo[ id ][ piClass ][ pciIdentificator ], gPlayerInfo[ id ][ piClass ] );
		ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], classBuffer );
		
		new iForward, iRet;
		iForward = CreateOneForward( classBuffer[ ciPlugin ], "ncod_classChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], NCODSTATE_DISABLE )
		DestroyForward( iForward );
	}
	
	gPlayerInfo[ id ][ piClass ] = { -1, 0, 0, 0, 0, 0, 0, 0, 0 };
	gPlayerInfo[ id ][ piMenuFirstTime ] = true;
	
	format( gPlayerBuffer[ id ][ cInfo ][ ciName ], 127, "Brak" );
	gPlayerBuffer[ id ][ bLastC ] = -1;
	
	iOldTeam[ id ] = get_user_team( id );
}

public eventRoundEnd( )
{
	for( new i = 1; i <= 32; i++ )
	{
		if( is_user_connected( i ) ) gPlayerInfo[ i ][ piMenuBlocked ] = false;
		if( is_user_alive( i ) )
		{
			gPlayerInfo[ i ][ piClass ][ pciExperience ] += 5 * gPlayerInfo[ i ][ piClass ][ pciLevel ];
                        
			printInformation( i, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Za przezycie rundy dostajesz +%d exp'a!",  5 * gPlayerInfo[ i ][ piClass ][ pciLevel ] );         
			checkPlayerLevel( i );
		}
	}
}

public hamSpawnPost( id )
{
	if( !is_user_alive( id ) || is_user_bot( id ) )
		return HAM_IGNORED;
		
	if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] == -1 || gPlayerInfo[ id ][ piMenuFirstTime ] )
	{
		cmdClass( id );
		return HAM_IGNORED;
	}
	
	if( gPlayerInfo[ id ][ piPerk ] != -1 )
	{
		new perkBuffer[ itemInfo ];
		ArrayGetArray( gaPerks, gPlayerInfo[ id ][ piPerk ], perkBuffer );
		
		new iRet, iForward = CreateOneForward( perkBuffer[ iiPlugin ], "ncod_perkChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piPerk ], NCODSTATE_SPAWN );
		DestroyForward( iForward );
	}
	
	setPlayerAbilities( id )
	distributePoints( id );
	
	return HAM_IGNORED ;
}

public hamRoundRespawnPost( id )
	client_cmd( id, "spk %s", get_user_team( id ) == 1 ? gszPluginSounds[ psStart ] : gszPluginSounds[ psStart2 ] );
	
public hamTakeDamage( iThis, iInflictor, iAttacker, Float: fDamage, iDamageBits )
{
	if( !is_user_alive( iAttacker ) || ( get_user_team( iAttacker ) == get_user_team( iThis ) ) )
		return HAM_IGNORED ;
		
	SetHamParamFloat( 4, fDamage - ( ( gPlayerInfo[ iThis ][ piClass ][ pciStrength ] * 0.08755 ) <= 0.0 ? 1.0 : gPlayerInfo[ iThis ][ piClass ][ pciStrength ] * 0.08755 ) );
	return HAM_HANDLED ;
}

public hamTraceAttackPost( iThis, iAttacker, Float: fDamage, Float: fDirection[ 3 ], iTrace, iDamageBits )
{
	if( gPluginInfo[ plFriendlyFireSounds ] && is_user_alive( iThis ) && is_user_alive( iAttacker ) && get_user_team( iThis ) == get_user_team( iAttacker ) && gPlayerInfo[ iThis ][ piNextEmitSound ] < get_gametime() )
	{
		emit_sound( iThis, CHAN_AUTO, gszPluginSounds[ structPluginSounds: random_num( psCheckFire1, psCheckFire3 ) ], VOL_NORM, 2.0, 0, PITCH_NORM );
		gPlayerInfo[ iThis ][ piNextEmitSound ] = any: ( get_gametime() + 3.0 );
	}

	if( !is_user_connected( iAttacker ) || gPlayerInfo[ iAttacker ][ piClass ][ pciIdentificator ] == -1 )
		return HAM_IGNORED;
		
	if( inOtherTeam( iThis, iAttacker ) )
		gPlayerInfo[ iAttacker ][ piClass ][ pciExperience ] += ( floatround( fDamage ) / 20 ) * ( get_tr2( iTrace, TR_iHitgroup ) == HIT_HEAD ? 85 : 50 );
		
	checkPlayerLevel( iAttacker );
		
	return HAM_IGNORED ;
}

public hamWeaponReloading( iWeapon )
{
	if( !gPluginInfo[ plReloadingSounds ] || !get_pdata_int( iWeapon, 54, 4 ) )
		return HAM_IGNORED;
		
	new iOwner = pev( iWeapon, pev_owner );

	emit_sound( iOwner, CHAN_AUTO, gszPluginSounds[ structPluginSounds: random_num( psReloading1, psReloading3 ) ], VOL_NORM, 2.0, 0, PITCH_NORM );
	gPlayerInfo[ iOwner ][ piNextEmitSound ] = any: ( get_gametime() + 3.0 );
	
	return HAM_IGNORED;
}

public hamShotgunReloading( iWeapon )
{
	if( !gPluginInfo[ plReloadingSounds ] || get_pdata_int( iWeapon, 55, 4 ) != 1 || get_pdata_float( iWeapon, 48, 4 ) != 0.55 )
		return HAM_IGNORED;
		
	new iOwner = pev( iWeapon, pev_owner );
	
	emit_sound( iOwner, CHAN_AUTO, gszPluginSounds[ structPluginSounds: random_num( psReloading1, psReloading3 ) ], VOL_NORM, 2.0, 0, PITCH_NORM );
	gPlayerInfo[ iOwner ][ piNextEmitSound ] = any: ( get_gametime() + 3.0 );
	
	return HAM_IGNORED;
}

public hamWeaponTouch( iEntity, id )
{
	new szModel[ 15 ];
	pev( iEntity, pev_model, szModel, 14 );
	
	return ( ( ( pev( iEntity, pev_owner ) == id ) || ( containi( szModel, "w_backpack" ) != -1 ) ) ? HAM_IGNORED : HAM_SUPERCEDE  );
}

public hamResetMaxSpeed( id )
	set_pev( id, pev_maxspeed, 230.0 + float( gPlayerInfo[ id ][ piClass ][ pciCondition ] ) );	

public fwEmitSound( id, iChannel, szSound[], Float: fVol, Float: fAttn, iFlags, iPitch ) 
{
	if( !is_user_alive( id ) )
		return FMRES_IGNORED;
		
	if( strfind( szSound, "wpn_denyselect.wav" ) != -1 )
	{
		if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] == -1 )
			return FMRES_IGNORED;
		
		new classBuffer[ classInfo ];
		ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], classBuffer );
	
		new iRet, iForward = CreateOneForward( classBuffer[ ciPlugin ], "ncod_classChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], NCODSTATE_USE );
		DestroyForward( iForward );
		
		return FMRES_SUPERCEDE;
	}

	return FMRES_IGNORED;
}

public fwPlayerPostThinkPost( id )
{
	if( is_user_bot( id ) || gfNextHUDRefresh[ id ] >= get_gametime( ) )
		return FMRES_IGNORED;
			
	gfNextHUDRefresh[ id ] = get_gametime( ) + 1.00;
	new iThis = is_user_alive( id ) ? id : pev( id, pev_iuser2 );
	
	if( is_user_alive( id ) )
		getHUDAddons( id )
	
	if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] != -1 && gPlayerBuffer[ id ][ bLastC ] != gPlayerInfo[ id ][ piClass ][ pciIdentificator ] )
	{
		ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], gPlayerBuffer[ id ][ cInfo ] );
		gPlayerBuffer[ id ][ bLastC ] = gPlayerInfo[ id ][ piClass ][ pciIdentificator ];
	}
		
	if( gPlayerBuffer[ id ][ bLastI ] != gPlayerInfo[ id ][ piPerk ] )
	{
		if( gPlayerInfo[ id ][ piPerk ] != -1 )
			ArrayGetArray( gaPerks, gPlayerInfo[ id ][ piPerk ], gPlayerBuffer[ id ][ iInfo ] );
		else
			formatex( gPlayerBuffer[ id ][ iInfo ][ iiName ], 63, "Brak" );
			
		gPlayerBuffer[ id ][ bLastI ] = gPlayerInfo[ id ][ piPerk ];
	}
	
	set_hudmessage( 255, 255, 255, 0.02, 0.2, 0, 0.0, 1.0, 0.1, 0.1 );
	ShowSyncHudMsg( id, gSyncHUD, 
		"[ Nick ]: %s^n[ Nazwa klasy ]: %s^n[ Level ]: %d^n[ Doswiadczenie ]: %d/%d^n[ Perk ]: %s^n[ Wytrzymalosc perku ]: %d/100%s",
		gPlayerInfo[ iThis ][ piName ], gPlayerBuffer[ iThis ][ cInfo ][ ciName ], gPlayerInfo[ iThis ][ piClass ][ pciLevel ], gPlayerInfo[ iThis ][ piClass ][ pciExperience ],
		( power( gPlayerInfo[ iThis ][ piClass ][ pciLevel ] + 1, 2 ) * gPluginInfo[ plExperienceMultiplier ] ), gPlayerBuffer[ iThis ][ iInfo ][ iiName ], gPlayerInfo[ iThis ][ piPerkDurability ], gPlayerBuffer[ iThis ][ bHUDAddons ]
	);
	
	return FMRES_IGNORED;
}

public commandBlock( id )
	return PLUGIN_HANDLED;

public setPlayerAbilities( id )
{
	set_pev( id, pev_health, 100.0 + float( gPlayerInfo[ id ][ piClass ][ pciHealth ] ) );
	
	new classBuffer[ classInfo ];
	ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], classBuffer );
	
	new bool:bC4 = false, szWeapon[ 64 ];
	if( pev( id, pev_weapons ) & CSW_C4 ) bC4 = true;
	
	fm_strip_user_weapons( id );
	fm_give_item( id, "weapon_knife" );
	
	for( new i = 1; i < 33; i ++ )
	{
		if( !( classBuffer[ ciWeapons ] & ( 1 << i ) ) )
			continue;
			
		get_weaponname( i, szWeapon, 63 );
		fm_give_item( id, szWeapon );
		fm_give_item( id, szWeapon );
		fm_give_item( id, szWeapon );
		fm_give_item( id, szWeapon );
	}
	
	if( bC4 ) fm_give_item( id, "weapon_c4" );
	
	new iRet, iForward = CreateOneForward( classBuffer[ ciPlugin ], "ncod_classChangeState", FP_CELL, FP_CELL, FP_CELL );
	ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], NCODSTATE_SPAWN );
	DestroyForward( iForward );
}

public checkPlayerLevel( id )
{
	if( gPlayerInfo[ id ][ piClass ][ pciLevel ] == gPluginInfo[ plMaxLevel ] )
		return ;
		
	new iOldLevel = gPlayerInfo[ id ][ piClass ][ pciLevel ] ;
	gPlayerInfo[ id ][ piClass ][ pciLevel ] = 0;
	
	while( gPlayerInfo[ id ][ piClass ][ pciExperience ] >= power( gPlayerInfo[ id ][ piClass ][ pciLevel ] + 1, 2 ) * gPluginInfo[ plExperienceMultiplier ] ) gPlayerInfo[ id ][ piClass ][ pciLevel ] ++;

	if( gPlayerInfo[ id ][ piClass ][ pciLevel ] > iOldLevel )
	{
		printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Gratulacje, awansowales do nastepnego poziomu!" );
		client_cmd( id, "spk %s", gszPluginSounds[ psLevelUp ] );
	}
	else if(gPlayerInfo[ id ][ piClass ][ pciLevel ] < iOldLevel )
	{
		printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Buuu, spadles do poziomu %i!", gPlayerInfo[ id ][ piClass ][ pciLevel ] );
		client_cmd( id, "spk %s", gszPluginSounds[ psLevelDegraded ] );
		cmdResetPlayerStats( id )
	}
}

public cmdResetPlayerStats( id )
{
	new iPoints = gPlayerInfo[ id ][ piClass ][ pciLevel ] * 2;
	
	new classBuffer[ classInfo ];
	ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], classBuffer );
	
	gPlayerInfo[ id ][ piClass ][ pciHealth ] = classBuffer[ ciHealth ];
	gPlayerInfo[ id ][ piClass ][ pciStrength ] = classBuffer[ ciStrength ];
	gPlayerInfo[ id ][ piClass ][ pciIntelligence ] = classBuffer[ ciIntelligence ];
	gPlayerInfo[ id ][ piClass ][ pciCondition ] = classBuffer[ ciCondition ];
	
	if( iPoints )
		distributePoints( id );
}

public loadPlayer( id )
{
	if( is_user_bot( id ) ) return;

	flushPlayerData( id );

	if( !gPlayerInfo[ id ][ piClasses ] )
		gPlayerInfo[ id ][ piClasses ] = _:ArrayCreate( playerClassInfo );

	get_user_name( id, gPlayerInfo[ id ][ piName ], 32 );
	
	new szPlayerID[ 33 ];
	getPlayerIdentificator( id, szPlayerID, 32 );

	new classBuffer[ classInfo ];
	new userClass[ playerClassInfo ];

	new szBuffer[ 1024 ];
	new szParsedData[ 6 ][ 128 ];

	new iTimeStamp;
	
	if( !gPluginInfo[ plSaveDriver ] || gPluginInfo[ plSaveDriver ] == 1 )
	{
		for( new i = 0; i < ArraySize( gaClasses ); i ++ )
		{
			ArrayGetArray( gaClasses, i, classBuffer );
			
			new iError = 1;

			if( gPluginInfo[ plSaveDriver ] == 1 )
			{
				format( szBuffer, 1023, "%s[:#$#:]%s", szPlayerID, classBuffer[ ciName ] );
				iError = !nvault_lookup( gVault, szBuffer, szBuffer, 1023, iTimeStamp );
			}

			if( iError )
			{
				userClass[ pciIdentificator ] = i;
				userClass[ pciLevel ] = 0;
				userClass[ pciExperience ] = 0;
				userClass[ pciHealth ] = classBuffer[ ciHealth ];
				userClass[ pciStrength ] = classBuffer[ ciStrength ];
				userClass[ pciIntelligence ] = classBuffer[ ciIntelligence ];
				userClass[ pciCondition ] = classBuffer[ ciCondition ];
				userClass[ pciWeapons ] = classBuffer[ ciWeapons ];
				userClass[ pciInitialPoints ] = classBuffer[ ciHealth ] +
												classBuffer[ ciStrength ] +
												classBuffer[ ciIntelligence ] +
												classBuffer[ ciCondition ] ;
	
				ArrayPushArray( gPlayerInfo[ id ][ piClasses ], userClass );
				continue;
			}
	
			parse( szBuffer, 
				szParsedData[ 0 ], 127,
				szParsedData[ 1 ], 127,
				szParsedData[ 2 ], 127,
				szParsedData[ 3 ], 127,
				szParsedData[ 4 ], 127,
				szParsedData[ 5 ], 127
			);
	
			userClass[ pciIdentificator ] = i;
			userClass[ pciLevel ] = str_to_num( szParsedData[ 0 ] );
			userClass[ pciExperience ] = str_to_num( szParsedData[ 1 ] );
			userClass[ pciHealth ] = str_to_num( szParsedData[ 2 ] );
			userClass[ pciStrength ] = str_to_num( szParsedData[ 3 ] );
			userClass[ pciIntelligence ] = str_to_num( szParsedData[ 4 ] );
			userClass[ pciCondition ] = str_to_num( szParsedData[ 5 ] );
			userClass[ pciWeapons ] = classBuffer[ ciWeapons ];
			userClass[ pciInitialPoints ] = classBuffer[ ciHealth ] +
											classBuffer[ ciStrength ] +
											classBuffer[ ciIntelligence ] +
											classBuffer[ ciCondition ] ;

			ArrayPushArray( gPlayerInfo[ id ][ piClasses ], userClass );
		}
	}
}

public savePlayer( id )
{
	if( is_user_bot( id ) ) return;

	new classBuffer[ classInfo ];
	new userClass[ playerClassInfo ];
	
	new szBuffer[ 2 ][ 1024 ];
	
	new szPlayerID[ 33 ];
	getPlayerIdentificator( id, szPlayerID, 32 );
	
	if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] != -1 )
		ArraySetArray( gPlayerInfo[ id ][ piClasses ], gPlayerInfo[ id ][ piClass ][ pciIdentificator ], gPlayerInfo[ id ][ piClass ] );
	
	if( gPluginInfo[ plSaveDriver ] == 1 )
	{
		for( new i = 0; i < ArraySize( gPlayerInfo[ id ][ piClasses ] ); i ++ )
		{
			ArrayGetArray( gPlayerInfo[ id ][ piClasses ], i, userClass );
			ArrayGetArray( gaClasses, userClass[ pciIdentificator ], classBuffer );

			if( gPluginInfo[ plSaveDriver ] == 1 )
			{
				format( szBuffer[ 0 ], 1023, "%s[:#$#:]%s", szPlayerID, classBuffer[ ciName ] );
				format( szBuffer[ 1 ], 1023, "%d %d %d %d %d %d",
					userClass[ pciLevel ],
					userClass[ pciExperience ],
					userClass[ pciHealth ],
					userClass[ pciStrength ],
					userClass[ pciIntelligence ],
					userClass[ pciCondition ]
				);

				nvault_set( gVault, szBuffer[ 0 ], szBuffer[ 1 ] ); 
			}
		}
	}
	
	flushPlayerData( id );
}

public flushPlayerData( id )
{
	format( gPlayerInfo[ id ][ piName ], 32, "" );
	gPlayerInfo[ id ][ piClass ] = { -1, 0, 0, 0, 0, 0, 0, 0, 0 };
	
	if( gPlayerInfo[ id ][ piClasses ] )
		ArrayDestroy( gPlayerInfo[ id ][ piClasses ] );

	gPlayerInfo[ id ][ piPerk ] = -1;
	gPlayerInfo[ id ][ piPerkDurability ] = 0;
	gPlayerInfo[ id ][ piMenuFirstTime ] = true;
	gPlayerInfo[ id ][ piDistributePointsMode ] = 0;
	
	format( gPlayerBuffer[ id ][ cInfo ][ ciName ], 63, "Brak" );
	format( gPlayerBuffer[ id ][ iInfo ][ iiName ], 63, "Brak" );
	
	gPlayerBuffer[ id ][ bLastC ] = -1;
	gPlayerBuffer[ id ][ bLastI ] = -1;
}

public getPlayerIdentificator( id, szOutput[], iLen )
{
	switch( gPluginInfo[ plSaveMode ] )
	{
		case 0: get_user_name( id, szOutput, iLen )
		case 1: get_user_ip( id, szOutput, iLen );
		case 2: get_user_authid( id, szOutput, iLen );
	}
}

public printInformation( id, NCodInfoType: iType, NCodInfoColor: iColor, const szMessage[ ], any:... )
{
	new szText[ 256 ];
	vformat( szText, 255, szMessage, 5 );

	switch( iType )
	{
		case NCODINFOTYPE_CHAT: {
			
			switch( iColor )
			{
				case NCODINFOCOLOR_NORMAL: ColorChat( id, TEAM_COLOR, "[^x04 NewCodMod^x03 ]^x01 %s", szText );  
				case NCODINFOCOLOR_INFORMATION: ColorChat( id, TEAM_COLOR, "[^x04 NewCodMod^x03 ]^x04 %s", szText );  
				case NCODINFOCOLOR_WARNING, NCODINFOCOLOR_PANIC:  ColorChat( id, RED, "[ NewCodMod ] %s", szText );  
				
				default: {}
			}
		}
		
		case NCODINFOTYPE_HUD: {
		
			switch( iColor )
			{
				case NCODINFOCOLOR_NORMAL: set_dhudmessage( 0, 0, 0, -1.0, 0.2, 0, 0.0, 3.0, 0.8, 1.0 ) ;
				case NCODINFOCOLOR_INFORMATION: set_dhudmessage( 0, 255, 0, -1.0, 0.2, 0, 0.0, 3.0, 0.8, 1.0 ) ;
				case NCODINFOCOLOR_WARNING: set_dhudmessage( 255, 0, 0, -1.0, 0.2, 0, 0.0, 3.0, 0.8, 1.0 ) ;
				case NCODINFOCOLOR_PANIC: set_dhudmessage( 255, 0, 0, -1.0, 0.2, 1, 2.5, 3.0, 0.8, 1.0 ) ;
				
				default: {}
			}
			
			show_dhudmessage( id, szText );
		}
		
		case NCODINFOTYPE_BOTH: {
		
			switch( iColor )
			{
				case NCODINFOCOLOR_NORMAL: { ColorChat( id, TEAM_COLOR, "[^x04 NewCodMod^x03 ]^x01 %s", szText ); set_dhudmessage( 0, 0, 0, -1.0, 0.2, 0, 0.0, 3.0, 0.8, 1.0 ) ; }
				case NCODINFOCOLOR_INFORMATION: { ColorChat( id, TEAM_COLOR, "[^x04 NewCodMod^x03 ]^x04 %s", szText );  set_dhudmessage( 0, 255, 0, -1.0, 0.2, 0, 0.0, 3.0, 0.8, 1.0 ) ; }
				case NCODINFOCOLOR_WARNING: { ColorChat( id, RED, "[ NewCodMod ] %s", szText ); set_dhudmessage( 255, 0, 0, -1.0, 0.2, 0, 0.0, 3.0, 0.8, 1.0 ) ; }
				case NCODINFOCOLOR_PANIC: { ColorChat( id, RED, "[ NewCodMod ] %s", szText ); set_dhudmessage( 255, 0, 0, -1.0, 0.2, 1, 4.5, 2.0, 0.8, 1.0 ) ; }
				
				default: {}
			}
			
			show_dhudmessage( id, szText );
		}
	}
	
	if( iColor == NCODINFOCOLOR_PANIC )
	{ 
		client_cmd( id, "spk %s", gszPluginSounds[ psPanicMessage ] );
		
		message_begin( MSG_ONE_UNRELIABLE, get_user_msgid( "ScreenFade" ), { 0, 0, 0 }, id );
		
		write_short( ( 1 << 12 ) * 2 );
		write_short( 1 << 5 );
		write_short( 0 );
		
		write_byte( 0 );
		write_byte( 0 );
		write_byte( 0 );
		write_byte( 255 );
		
		message_end( );
	}
}

public getHUDAddons( id )
{
	new szBuff[ 127 ], iRet;
	
	format( gPlayerBuffer[ id ][ bHUDAddons ], 767, "" );
	
	for( new i = 0; i < ArraySize( gaHUDAddons ); i ++ )
	{
		format( szBuff, 127, "" );
	
		new iForward = CreateOneForward( ArrayGetCell( gaHUDAddons, i ), "ncod_hudRefresh", FP_CELL, FP_ARRAY );
		ExecuteForward( iForward, iRet, id, PrepareArray( szBuff, 128, 1 ) );
		DestroyForward( iForward );
		
		if( !szBuff[ 0 ] )
			continue;
		
		add( gPlayerBuffer[ id ][ bHUDAddons ], 767, "^n" );
		add( gPlayerBuffer[ id ][ bHUDAddons ], 767, szBuff );
	}
}

public distributePoints( id )
{
	static szPlayerMode[ 33 ][ 16 ];

	new iPoints = ( gPlayerInfo[ id ][ piClass ][ pciLevel ] * 2 ) - ( ( 
		gPlayerInfo[ id ][ piClass ][ pciHealth  ] + 
		gPlayerInfo[ id ][ piClass ][ pciStrength ] + 
		gPlayerInfo[ id ][ piClass ][ pciIntelligence ] + 
		gPlayerInfo[ id ][ piClass ][ pciCondition ] 
	) - gPlayerInfo[ id ][ piClass ][ pciInitialPoints ] ) ;
	
	if( !iPoints )
		return ;
		
	new iMenu = menu_create( "NewCodMod :: Rozdaj punkty", "distributePointsH" );
	new szBuffer[ 256 ];
	
	if( giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] != -1 )
		num_to_str( giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ], szPlayerMode[ id ], 15 );
	else
		format( szPlayerMode[ id ], 15, "WSZYSTKO" );
	
	format( szBuffer, 255, "Ile dodac? : %s^n", szPlayerMode[ id ] );
	menu_additem( iMenu, szBuffer );
	
	format( szBuffer, 255, "%s%s do Zdrowia [ %i / %i ] ( Zwieksza ilosc punktow zycia )", giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] != -1 ? "+" : "", szPlayerMode[ id ], gPlayerInfo[ id ][ piClass ][ pciHealth ], gPluginInfo[ plMaxStatisticValue ] )
	menu_additem( iMenu, szBuffer )
	format( szBuffer, 255, "%s%s do Wytrzymalosci [ %i / %i ] ( Stajesz sie odporniejszy )", giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] != -1 ? "+" : "", szPlayerMode[ id ], gPlayerInfo[ id ][ piClass ][ pciStrength ], gPluginInfo[ plMaxStatisticValue ] )
	menu_additem( iMenu, szBuffer )
	format( szBuffer, 255, "%s%s do Inteligencji [ %i / %i ] ( Zwieksza sile umiejetnosci klasy i perkow )", giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] != -1 ? "+" : "", szPlayerMode[ id ], gPlayerInfo[ id ][ piClass ][ pciIntelligence ], gPluginInfo[ plMaxStatisticValue ] )
	menu_additem( iMenu, szBuffer )
	format( szBuffer, 255, "%s%s do Kondycji [ %i / %i ] ( Szybciej sie poruszasz )", giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] != -1 ? "+" : "", szPlayerMode[ id ], gPlayerInfo[ id ][ piClass ][ pciCondition ], gPluginInfo[ plMaxStatisticValue ] )
	menu_additem( iMenu, szBuffer )
	
	format( szBuffer, 255, "[x] Wyjdz^n^nPozostalo Ci %i pkt do rozdania.", iPoints )
	menu_setprop( iMenu, MPROP_EXITNAME, szBuffer );
	
	menu_setprop( iMenu, MPROP_BACKNAME, "[<-] Wroc" );
	menu_setprop( iMenu, MPROP_NEXTNAME, "[->] Dalej" );
	
	menu_display( id, iMenu );
}

public distributePointsH( id, iMenu, iItem )
{
	new iPoints = ( gPlayerInfo[ id ][ piClass ][ pciLevel ] * 2 ) - ( ( 
		gPlayerInfo[ id ][ piClass ][ pciHealth ] + 
		gPlayerInfo[ id ][ piClass ][ pciStrength ] + 
		gPlayerInfo[ id ][ piClass ][ pciIntelligence ] + 
		gPlayerInfo[ id ][ piClass ][ pciCondition ] 
	) - gPlayerInfo[ id ][ piClass ][ pciInitialPoints ] ) ;
	
	
	client_cmd( id, "spk %s", gszPluginSounds[ psSelectMenuItem ] );
	
	if( iItem == 0 ) { gPlayerInfo[ id ][ piDistributePointsMode ] = ( ++gPlayerInfo[ id ][ piDistributePointsMode ] > sizeof( giDistributePointsModes ) - 1 ? 0 : gPlayerInfo[ id ][ piDistributePointsMode ] ); distributePoints( id ); return; }
	else if( iItem == MENU_EXIT ) { menu_destroy( iMenu ); return; }
	
	new iPointsToAdd = giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] != -1 ? giDistributePointsModes[ gPlayerInfo[ id ][ piDistributePointsMode ] ] : iPoints ;
	new any: iState = iItem + 2;
	
	if( gPlayerInfo[ id ][ piClass ][ iState ] == gPluginInfo[ plMaxStatisticValue ] )
		printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, gszStateInfo[ iState - 3 ] );
	else if( iPointsToAdd > iPoints )
		printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Masz niewystarczajaca ilosc punktow." );
	else
		gPlayerInfo[ id ][ piClass ][ iState ] += ( gPlayerInfo[ id ][ piClass ][ iState ] + iPointsToAdd ) > gPluginInfo[ plMaxStatisticValue ] ? gPluginInfo[ plMaxStatisticValue ] - gPlayerInfo[ id ][ piClass ][ iState ] : iPointsToAdd;
		
	menu_destroy( iMenu );
	distributePoints( id );
}

public cmdClass( id )
{	
	if( gPlayerInfo[ id ][ piMenuBlocked ] )
		return PLUGIN_HANDLED;
	else if( is_user_alive( id ) && !gPlayerInfo[ id ][ piMenuFirstTime ]  )
	{
		printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Mozliwosc wyboru klasy zostala odblokowana. Menu wyswietli sie przy nastepnym respawn'ie" ) ;
		gPlayerInfo[ id ][ piMenuFirstTime ] = gPlayerInfo[ id ][ piMenuBlocked ] = true;
		
		return PLUGIN_HANDLED;
	}
	else if( !is_user_alive( id ) )
		gPlayerInfo[ id ][ piMenuFirstTime ] = false;

	new iMenu = menu_create( "NewCodMod :: Wybierz klase", "cmdClassH" );
	new szBuffer[ 256 ], szClassID[ 5 ];
	new classBuffer[ classInfo ], playerClassBuffer[ playerClassInfo ];
	
	for( new i = 0; i < ArraySize( gaClasses ); i ++ )
	{
		ArrayGetArray( gaClasses, i, classBuffer );
		
		if( !classBuffer[ ciTeam ] || get_user_team( id ) == classBuffer[ ciTeam ]  )
		{
			ArrayGetArray( gPlayerInfo[ id ][ piClasses ], i, playerClassBuffer );
		
			format( szBuffer, 255, "%s [ %i ]", classBuffer[ ciName ], playerClassBuffer[ pciLevel ] );
			num_to_str( i, szClassID, 4 );
		
			menu_additem( iMenu, szBuffer, szClassID );
		}
	}
	
	menu_setprop( iMenu, MPROP_PERPAGE, 0 );
	menu_display( id, iMenu );
	
	return PLUGIN_HANDLED;
}

public cmdClassH( id, iMenu, iItem )
{
	client_cmd( id, "spk %s", gszPluginSounds[ psSelectMenuItem ] );

	if( iItem == MENU_EXIT )
	{
		menu_destroy( iMenu );
		return PLUGIN_HANDLED;
	}
	
	new iAccess, iCallback, iClassID, iForward;
	new szClassID[ 5 ], szName[ 33 ];
	
	menu_item_getinfo( iMenu, iItem, iAccess, szClassID, 4, szName, 32, iCallback );
	iClassID = str_to_num( szClassID );
	
	new classBuffer[ classInfo ];
	new iRet;
	
	if( gPlayerInfo[ id ][ piClass ][ pciIdentificator ] != -1 )
	{
		ArraySetArray( gPlayerInfo[ id ][ piClasses ], gPlayerInfo[ id ][ piClass ][ pciIdentificator ], gPlayerInfo[ id ][ piClass ] );
		ArrayGetArray( gaClasses, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], classBuffer );
		
		iForward = CreateOneForward( classBuffer[ ciPlugin ], "ncod_classChangeState", FP_CELL, FP_CELL, FP_CELL );
		ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piClass ][ pciIdentificator ], NCODSTATE_DISABLE )
		DestroyForward( iForward );
	}
	
	ArrayGetArray( gaClasses, iClassID, classBuffer );
	
	if( classBuffer[ ciAccessFlags ] != 0 && !( get_user_flags( id ) & classBuffer[ ciAccessFlags ] ) )
	{	
		printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nie masz dostepu do tej klasy." )
		cmdClass( id )
		
		return PLUGIN_HANDLED
	}
	
	ArrayGetArray( gPlayerInfo[ id ][ piClasses ], iClassID, gPlayerInfo[ id ][ piClass ] );
	
	iForward = CreateOneForward( classBuffer[ ciPlugin ], "ncod_classChangeState", FP_CELL, FP_CELL, FP_CELL );
	ExecuteForward( iForward, iRet, id, iClassID, NCODSTATE_ENABLE )
	DestroyForward( iForward );
	
	checkPlayerLevel( id );
	
	if( gPlayerInfo[ id ][ piMenuFirstTime ] )
	{
		setPlayerAbilities( id )
		gPlayerInfo[ id ][ piMenuFirstTime ] = false;
	}
	
	return PLUGIN_HANDLED
}


public cmdClasses( id )
{
	new iMenu = menu_create( "NewCodMod :: Wybierz klase", "cmdClassesH" )
	new classBuffer[ classInfo ], szBuffer[ 128 ], iCID[ 1 ];
	
	for( new i = 0; i < ArraySize( gaClasses ); i++ )
	{
		ArrayGetArray( gaClasses, i, classBuffer );
		
		format( szBuffer, 127, "%s [ Druzyna: %s ]", classBuffer[ ciName ], ( NCodTeams:classBuffer[ ciTeam ] == NCODTEAM_ALL ) ? "KAZDA" : ( ( NCodTeams:classBuffer[ ciTeam ] == NCODTEAM_TERRORIST ) ? "TERRORYSCI" : "AMERYKANIE" ) ); 
		iCID[ 0 ] = i;
		
		menu_additem( iMenu, szBuffer, iCID );
	}
	
	menu_setprop( iMenu, MPROP_BACKNAME, "[<-] Wroc" );
	menu_setprop( iMenu, MPROP_NEXTNAME, "[->] Dalej" );
	menu_setprop( iMenu, MPROP_EXITNAME, "[x] Wyjdz" );
	
	menu_display( id, iMenu )
	
	return PLUGIN_HANDLED;
}

public cmdClassesH( id, iMenu, iItem )
{
	client_cmd( id, "spk %s", gszPluginSounds[ psSelectMenuItem ] );

	if( iItem == MENU_EXIT )
	{
		menu_destroy( iMenu );
		return PLUGIN_HANDLED
	}
	
	new iNothing[ 1 ], iCID[ 1 ];
	menu_item_getinfo( iMenu, iItem, iNothing[ 0 ], iCID, 1, iNothing, 1, iNothing[ 0 ] );
	
	new classBuffer[ classInfo ];
	ArrayGetArray( gaClasses, iCID[ 0 ], classBuffer );
	
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nazwa klasy: %s", classBuffer[ ciName ] )
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Opis klasy: %s", classBuffer[ ciDescription ] )
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Podstawowe statystyki: Z: %d | W: %i | I: %d | K: %d", classBuffer[ ciHealth ], classBuffer[ ciStrength ], classBuffer[ ciIntelligence ], classBuffer[ ciCondition ] )

	cmdClasses( id );
	
	return PLUGIN_CONTINUE;
}

public cmdPerk( id )
{
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nazwa perku: %s", gPlayerBuffer[ id ][ iInfo ][ iiName ] )
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Opis perku: %s", gPlayerBuffer[ id ][ iInfo ][ iiDescription ] )
	
	return PLUGIN_HANDLED;
}

public cmdPerks( id )
{
	new iMenu = menu_create( "NewCodMod :: Wybierz perk", "cmdPerksH" )
	new perkBuffer[ itemInfo ], iPID[ 1 ];
	
	for( new i = 0; i < ArraySize( gaPerks ); i++ )
	{
		ArrayGetArray( gaPerks, i, perkBuffer );
		
		iPID[ 0 ] = i;
		menu_additem( iMenu, perkBuffer[ iiName ], iPID );
	}
	
	menu_setprop( iMenu, MPROP_BACKNAME, "[<-] Wroc" );
	menu_setprop( iMenu, MPROP_NEXTNAME, "[->] Dalej" );
	menu_setprop( iMenu, MPROP_EXITNAME, "[x] Wyjdz" );
	
	menu_display( id, iMenu )
	
	return PLUGIN_HANDLED;
}

public cmdPerksH( id, iMenu, iItem )
{
	client_cmd( id, "spk %s", gszPluginSounds[ psSelectMenuItem ] );

	if( iItem == MENU_EXIT )
	{
		menu_destroy( iMenu );
		return PLUGIN_HANDLED
	}
	
	new iNothing[ 1 ], iCID[ 1 ];
	menu_item_getinfo( iMenu, iItem, iNothing[ 0 ], iCID, 1, iNothing, 1, iNothing[ 0 ] );
	
	new perkBuffer[ itemInfo ];
	ArrayGetArray( gaPerks, iCID[ 0 ], perkBuffer );
	
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nazwa perku: %s", perkBuffer[ iiName ] )
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Opis perku: %s", perkBuffer[ iiDescription ] )
	
	return PLUGIN_CONTINUE ;
}

public cmdDropPerk( id )
{
	if( gPlayerInfo[ id ][ piPerk ] == -1 )
		return;

	new perkBuffer[ itemInfo ];
	ArrayGetArray( gaPerks, gPlayerInfo[ id ][ piPerk ], perkBuffer );
		
	new iRet, iForward = CreateOneForward( perkBuffer[ iiPlugin ], "ncod_perkChangeState", FP_CELL, FP_CELL, FP_CELL );
	ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piPerk ], NCODSTATE_DISABLE );
	DestroyForward( iForward );
	
	gPlayerInfo[ id ][ piPerk ] = -1;
	gPlayerInfo[ id ][ piPerkDurability ] = 0;
	
	printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Wyrzuciles perk!" );
}

public cmdUsePerk( id )
{
	if( gPlayerInfo[ id ][ piPerk ] == -1 )
		return PLUGIN_HANDLED;
		
	new perkBuffer[ itemInfo ];
	ArrayGetArray( gaPerks, gPlayerInfo[ id ][ piPerk ], perkBuffer );
	
	new iRet, iForward = CreateOneForward( perkBuffer[ iiPlugin ], "ncod_perkChangeState", FP_CELL, FP_CELL, FP_CELL );
	ExecuteForward( iForward, iRet, id, gPlayerInfo[ id ][ piPerk ], NCODSTATE_USE );
	DestroyForward( iForward );
	
	return PLUGIN_HANDLED;
}
	
// ncod_registerClass( const szName[ ], const szDescription[ ], const iHealth, const iArmor, const iDexterity, const iCondition, const iTeam = TEAM_UNASSIGNED, const iAccessFlags = 0 )
public nativeRegisterClass( iPlugin, iParams )
{
	if( iParams != 9 )
	{
		new szPlugin[ 2 ][ 64 ];
		get_plugin( iPlugin, szPlugin[ 0 ], 63, szPlugin[ 1 ], 63 );
		
		log_amx( "[ %s < %s > ]: Blad przy rejestracji klasy!", szPlugin[ 1 ], szPlugin[ 0 ] );
		return -1;
	}
	
	new ciClass[ classInfo ] ;
	
	get_string( 1, ciClass[ ciName ], 63 );
	get_string( 2, ciClass[ ciDescription ], 127 );
	ciClass[ ciHealth ] = get_param( 3 );
	ciClass[ ciStrength ] = get_param( 4 );
	ciClass[ ciIntelligence ] = get_param( 5 );
	ciClass[ ciCondition ] = get_param( 6 );
	ciClass[ ciWeapons ] = get_param( 7 );
	ciClass[ ciTeam ] = get_param( 8 );
	ciClass[ ciAccessFlags ] = get_param( 9 );
	ciClass[ ciPlugin ] = iPlugin;
	
	return ArrayPushArray( gaClasses, ciClass );
}

// ncod_registerPerk( const szName[ ], const szDescription[ ], const iAccessFlags = 0 )
public nativeRegisterPerk( iPlugin, iParams )
{
	if( iParams != 3 )
	{
		new szPlugin[ 2 ][ 64 ];
		get_plugin( iPlugin, szPlugin[ 0 ], 63, szPlugin[ 1 ], 63 );
		
		log_amx( "[ %s < %s > ]: Blad przy rejestracji perku!", szPlugin[ 1 ], szPlugin[ 0 ] );
		return -1;
	}
	
	new iiPerk[ itemInfo ];
	
	get_string( 1, iiPerk[ iiName ], 63 );
	get_string( 2, iiPerk[ iiDescription ], 127 );
	iiPerk[ iiAccessFlags ] = get_param( 3 );
	iiPerk[ iiPlugin ] = iPlugin;
	
	return ArrayPushArray( gaPerks, iiPerk ); 
}

// ncod_getUserStats( id, NCodStatist: iStatist )
public nativeGetUserStatist( iPlugin, iParams )
{
	if( iParams != 2 )
	{
		new szPlugin[ 2 ][ 64 ];
		get_plugin( iPlugin, szPlugin[ 0 ], 63, szPlugin[ 1 ], 63 );
		
		log_amx( "[ %s < %s > ]: Blad przy pobieraniu wartosci statystyki!", szPlugin[ 1 ], szPlugin[ 0 ] );
		return -1;
	}
	
	return gPlayerInfo[ get_param( 1 ) ][ playerInfo: giStatistics[ NCodStatist: get_param( 2 ) ] ];
}

// ncod_setUserStats( id, NCodStatist: iStatist, iValue )
public nativeSetUserStatist( iPlugin, iParams )
{
	if( iParams != 3 )
	{
		new szPlugin[ 2 ][ 64 ];
		get_plugin( iPlugin, szPlugin[ 0 ], 63, szPlugin[ 1 ], 63 );
		
		log_amx( "[ %s < %s > ]: Blad przy pobieraniu wartosci statystyki!", szPlugin[ 1 ], szPlugin[ 0 ] );
		return -1;
	}
	
	if( any: get_param( 2 ) != NCODSTATIST_LEVEL )
		gPlayerInfo[ get_param( 1 ) ][ playerInfo: giStatistics[ NCodStatist: get_param( 2 ) ] ] = get_param( 3 );
	else
	{
		gPlayerInfo[ get_param( 1 ) ][ playerInfo: giStatistics[ NCODSTATIST_EXPERIENCE ] ] = power( get_param( 3 ), 2 ) * gPluginInfo[ plExperienceMultiplier ];
		gPlayerInfo[ get_param( 1 ) ][ playerInfo: giStatistics[ NCODSTATIST_LEVEL ] ] = get_param( 3 );
	}
	
	return 0;
}

// ncod_printInformation( id, NCodInfoType: iType, NCodInfoColor: iColor, const szMessage[ ], any:... )
public nativePrintInformation( iPlugin, iParams )
{
	if( iParams < 4 )
	{
		new szPlugin[ 2 ][ 64 ];
		get_plugin( iPlugin, szPlugin[ 0 ], 63, szPlugin[ 1 ], 63 );
		
		log_amx( "[ %s < %s > ]: Blad przy probie wyswietlenia informacji!", szPlugin[ 1 ], szPlugin[ 0 ] );
		return -1;
	}
	
	new szText[ 256 ];
	vdformat( szText, 255, 4, 5 )
	
	printInformation( get_param( 1 ), NCodInfoType: get_param( 2 ), NCodInfoColor: get_param( 3 ), szText );
	
	return 0;
}

// ncod_registerHUDAddon( )
public nativeRegisterHUDAddon( iPlugin, iParams )
	return ArrayPushCell( gaHUDAddons, iPlugin );
	
__registerPluginCommands( )
{
	register_clcmd( "say /klasa", "cmdClass" );
	register_clcmd( "say_team /klasa", "cmdClass" );
	
	register_clcmd( "say /klasy", "cmdClasses" );
	register_clcmd( "say_team /klasy", "cmdClasses" );
	
	register_clcmd( "say /perk", "cmdPerk" );
	register_clcmd( "say_team /perk", "cmdPerk" );
	register_clcmd( "say /przedmiot", "cmdPerk" );
	register_clcmd( "say_team /przedmiot", "cmdPerk" );
	
	register_clcmd( "say /perki", "cmdPerks" );
	register_clcmd( "say_team /perki", "cmdPerks" );
	register_clcmd( "say /przedmioty", "cmdPerks" );
	register_clcmd( "say_team /przedmioty", "cmdPerks" );
	
	register_clcmd( "say /wyrzuc", "cmdDropPerk" );
	register_clcmd( "say_team /wyrzuc", "cmdDropPerk" );
	register_clcmd( "say /drop", "cmdDropPerk" );
	register_clcmd( "say_team /drop", "cmdDropPerk" );
	
	register_clcmd( "useperk", "cmdUsePerk" );
	register_clcmd( "radio3", "cmdUsePerk" );
	
	new szBuff[ 33 ];
	for( new i = 0; i < sizeof( gszWeaponsNames ) - 1; i ++ )
	{
		split( gszWeaponsNames[ i ], szBuff, 32, szBuff, 32, "weapon_" );
		register_clcmd( szBuff, "commandBlock" );
	}
	
	register_clcmd( "hegren", "commandBlock" );
}

__loadConfigFile( )
{
	new szFile[ 128 ];
	
	get_configsdir( szFile, 127 );
	format( szFile, 127, "%s/newcodmod.ini", szFile );
	
	if( !file_exists( szFile ) )
	{
		new iFile = fopen( szFile, "wt" );
		
		fputs( iFile, "# Plik konfiguracyjny NewCodMod^n^n" );

		fputs( iFile, "[ Global ]^n" );
		fputs( iFile, "maxLevel = 901^n" );
		fputs( iFile, "experienceMultiplier = 127^n" );
		fputs( iFile, "maxStatisticValue = 500^n" );
		
		fputs( iFile, "^n[ Sounds ]^n" );
		fputs( iFile, "reloadingSounds = 1^n" );
		fputs( iFile, "friendlyFireSounds = 1^n" );
		
		fputs( iFile, "^n[ Save Settings ]^n" );
		fputs( iFile, "saveDriver = 1^n" );
		fputs( iFile, "saveMode = 0^n" );
		fputs( iFile, "^n; Jezeli nie uzywasz MySQL, pozostaw bez zmian^n" );
		fputs( iFile, "mysqlHost = 127.0.0.1^n" );
		fputs( iFile, "mysqlUser = root^n" );
		fputs( iFile, "mysqlPassword = your_password^n" );
		fputs( iFile, "mysqlDatabase = your_lovely_db^n" );
		fputs( iFile, "mysqlPrefix = ncd_^n" );
		
		fclose( iFile );
	}
	else
	{
		new iFile = fopen( szFile, "rt" );
		new szBuffer[ 256 ], szKey[ 128 ], szValue[ 128 ];
		
		while( !feof( iFile ) )
		{
			fgets( iFile, szBuffer, 255 );
			if( !szBuffer[ 0 ] || szBuffer[ 0 ] == ' ' || szBuffer[ 0 ] == '#' || szBuffer[ 0 ] == ';' || szBuffer[ 0 ] == '[' )
				continue;
				
			strtok( szBuffer, szKey, 127, szValue, 127, '=' );
			
			trim( szKey );
			trim( szValue );
			replace_all( szValue, 127, "^"", "" );
			
			__packData( szKey, szValue );
		}
	}
}

__packData( szKey[], szValue[] )
{
	enum structDataScheme { szName[ 64 ], structPluginInfo:enumType, bool:isInt };
	new const dataScheme[ ][ structDataScheme ] = {
		{ "maxLevel",  plMaxLevel, true },
		{ "experienceMultiplier", plExperienceMultiplier, true },
		{ "maxStatisticValue", plMaxStatisticValue, true },
		{ "saveDriver", plSaveDriver, true },
		{ "saveMode", plSaveMode, true },
		{ "reloadingSounds", plReloadingSounds, true },
		{ "friendlyFireSounds", plFriendlyFireSounds, true },
		{ "mysqlHost", plMySQLHost, false },
		{ "mysqlUser", plMySQLUser, false },
		{ "mysqlPassword", plMySQLPassword, false },
		{ "mysqlDatabase", plMySQLDatabase, false },
		{ "mysqlPrefix", plMySQLPrefix, false }
	};

	new iScheme = -1;
	
	for( new i = 0; i < sizeof( dataScheme ) - 1; i ++ )
		if( equali( dataScheme[ i ][ szName ], szKey ) ) { iScheme = i; break; }
		
	if( iScheme == -1 )
		return;
		
	if( dataScheme[ iScheme ][ isInt ] )
		gPluginInfo[ dataScheme[ iScheme ][ enumType ] ] = str_to_num( szValue );
	else
		copy( gPluginInfo[ dataScheme[ iScheme ][ enumType ] ], 127, szValue )
}
