#include < amxmodx >
#include < fakemeta_util >
#include < hamsandwich >

#include "ncodmod.inc"

new bool: gHasPerk[ 33 ] = { false };
new gsExplosion ;

public plugin_init( )
{
	ncod_registerPerk( 
			"Meczennik",
			"Perk, który sprawia, że po zabiciu gracza upuszcza on granat pośmiertny, który może wyrządzić dodatkowe szkody innym graczom."
	);
	
	RegisterHam( Ham_Killed, "player", "hamPlayerKilledPost", 1 );
	RegisterHam( Ham_Think, "grenade", "hamFakeGrenadeThink", 1 );
}

public plugin_precache( )
{
	engfunc( EngFunc_PrecacheModel, "models/w_hegrenade.mdl" );
	gsExplosion = engfunc( EngFunc_PrecacheModel, "sprites/blast.spr" );
}

public ncod_perkChangeState( id, iPerk, NCodState: iState )
{
	switch( iState )
	{
		case NCODSTATE_ENABLE: gHasPerk[ id ] = true;
		case NCODSTATE_DISABLE: gHasPerk[ id ] = false;
		default: {}
	}
}

public hamPlayerKilledPost( iThis, iAttacker, iShouldGibs )
{
	if( ! gHasPerk[ iThis ] )
		return;
		
	new Float: fOrigin[ 3 ];
	pev( iThis, pev_origin, fOrigin );
	fOrigin[ 2 ] += 5.5;

	new iGrenade = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "grenade" ) );
	
	set_pev( iGrenade, pev_classname, "fake_grenade" );
	engfunc( EngFunc_SetModel, iGrenade, "models/w_hegrenade.mdl" );
	engfunc( EngFunc_SetOrigin, iGrenade, fOrigin );
	
	set_pev( iGrenade, pev_gravity, 1.0 );
	set_pev( iGrenade, pev_nextthink, get_gametime( ) + 2.5 );
	set_pev( iGrenade, pev_solid, SOLID_BBOX );
	set_pev( iGrenade, pev_movetype, MOVETYPE_TOSS );
	set_pev( iGrenade, pev_owner, iThis );
}

public hamFakeGrenadeThink( iGrenade )
{
	new szClassName[ 33 ];
	pev( iGrenade, pev_classname, szClassName, 32 );
	
	if( ! equali( szClassName, "fake_grenade" ) )
		return;
		
	new Float: fOrigin[ 3 ];
	new iOwner = pev( iGrenade, pev_owner );
	
	engfunc( EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fOrigin, 0 );
	write_byte( TE_EXPLOSION );
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( gsExplosion );
	write_byte( 32 );
	write_byte( 20 );
	write_byte( 0 );
	message_end( );
	
	new iPlayer = 0;
	while( ( iPlayer = fm_find_ent_in_sphere( iPlayer, fOrigin, 150 ) ) != 0 )
	{
		if( is_user_alive( iPlayer ) && iPlayer != iOwner )
			ExecuteHamB( Ham_TakeDamage, 
					iPlayer, 
					iOwner, 
					iOwner,
					35.0,
					DMG_BLAST
			);
	}
	
	engfunc( EngFunc_RemoveEntity, iGrenade );
}